/*
 * semaphore.c
 *
 * use of Window Semaphore
 * 
 *
 * Bernhard Rabe
 * 18.05.2006
 *
 */
#include <windows.h>
#include <stdio.h>


/*semaphore*/
HANDLE hSem; 
 
void printErrorAndExit(const char *msg, DWORD err,int id)
{
	LPSTR lpMsgBuf;
	if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|
			          FORMAT_MESSAGE_FROM_SYSTEM | 
					  FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL,
						err,
					  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					  (LPTSTR) &lpMsgBuf,
					  0,
					  NULL ))
	{
		fprintf(stderr,"%s %d : %s\n",msg,id,lpMsgBuf);
		LocalFree(lpMsgBuf);
	}
	else
	{
		fprintf(stderr,"Error at FormatMesage: %d\n",err=GetLastError());
	}
	exit(err);
} 
 
/* Thread routine*/ 
DWORD WINAPI run(LPVOID data)
{
    do
    {
      DWORD ret,id;
      id=GetCurrentThreadId();
        
      if(WAIT_OBJECT_0!=(ret=WaitForSingleObject(hSem,0)))
      {
	    if(WAIT_TIMEOUT==ret)      
           printf("%d kein semaphore frei\n",id);
	    else
        {
          printErrorAndExit("WaitForSingleObject",GetLastError(),id);	
        }
        Sleep(1);  
      }
      else
      {
          printf("%d semaphore erhalten\n",id);   
          Sleep(3); 
          if(!ReleaseSemaphore(hSem,1,NULL))
            printErrorAndExit("ReleaseSemaphore",GetLastError(),id);
          
          printf("%d semaphore freigegeben\n",id);
          break;
      }
      
    }while(1);
    
    return 0;
}


int main()
{
    int i,errval;
    HANDLE pthread[10];
    /*concurrency of 2 threads*/


    if(NULL==(hSem=CreateSemaphore(NULL,2,2,NULL)))
        printErrorAndExit("CreateSemaphore",GetLastError(),-1);       
    
    for(i=0;i<5;i++)
    {
        if(NULL==(pthread[i]=CreateThread(NULL,0,run,NULL,0,NULL)))
            printErrorAndExit("CreateThread",GetLastError(),-1);
    }
    
    if(WAIT_FAILED==WaitForMultipleObjects(5,pthread,TRUE,INFINITE))
        printErrorAndExit("WaitForMultipleObjects",GetLastError(),-1);
    
    for(i=0;i<5;i++)
        if(!CloseHandle(pthread[i]))
            fprintf(stderr,"Error at CloseHandle\n");
    
    
    if(!CloseHandle(hSem))
        printErrorAndExit("CloseHandle",GetLastError(),-1);
        
    return 0;    
}
